//+------------------------------------------------------------------+
//|                                                          RVI.mq4 |
//|                                                              TTK |
//|                                     https://youtu.be/LjIAzKo62MQ |
//+------------------------------------------------------------------+
#property copyright "TTK"
#property link      "https://youtu.be/LjIAzKo62MQ"
#property version   "1.00"
#property strict
#property indicator_chart_window
#property indicator_buffers 2

//---
#include <CUSTOM/VTLS.mqh>
//---

//---
extern string RELATIVE_VIGOR_INDEX_SETTINGS;
input int signals_to_show = 50;
input color buy_signal_colour = clrMediumSeaGreen;
input color sell_signal_colour = clrRed;
//---

//---
int buy_index = 0;
int sell_index = 0;
//---

//---
double LONG_TRADES[];
double SHORT_TRADES[];
//---

//---
double previous_relative_vigor_index;
double current_relative_vigor_index;
double previous_relative_vigor_index_signal_line;
double current_relative_vigor_index_signal_line;
//---

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
   IndicatorDigits(Digits);
//--- indicator buffers mapping
   SetIndexStyle(0, DRAW_ARROW, STYLE_SOLID, 3, buy_signal_colour);
   SetIndexBuffer(0, LONG_TRADES);
   SetIndexLabel(0, "LONG_TRADES");
   SetIndexArrow(0, 234);
//---
   SetIndexStyle(1, DRAW_ARROW, STYLE_SOLID, 3, sell_signal_colour);
   SetIndexBuffer(1, SHORT_TRADES);
   SetIndexLabel(1, "SHORT_TRADES");
   SetIndexArrow(1, 233);
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//--- destroy timer
//EventKillTimer();
   
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   /*ArraySetAsSeries(
      LONG_TRADES_END,
      TRUE
   );

   ArraySetAsSeries(
      SHORT_TRADES_END,
      TRUE
   );*/

   if(is_new_candle())
     {
      for(int candle_number = signals_to_show; candle_number > 0; candle_number--)
        {
         previous_relative_vigor_index = iRVI(
                                            NULL,
                                            0,
                                            10,
                                            MODE_MAIN,
                                            candle_number + 1
                                         );

         current_relative_vigor_index = iRVI(
                                           NULL,
                                           0,
                                           10,
                                           MODE_MAIN,
                                           candle_number
                                        );

         previous_relative_vigor_index_signal_line = iRVI(
                  NULL,
                  0,
                  10,
                  MODE_SIGNAL,
                  candle_number + 1
               );

         current_relative_vigor_index_signal_line = iRVI(
                  NULL,
                  0,
                  10,
                  MODE_SIGNAL,
                  candle_number
               );

         if((previous_relative_vigor_index > previous_relative_vigor_index_signal_line) && (current_relative_vigor_index < current_relative_vigor_index_signal_line))
           {
            LONG_TRADES[buy_index] = High[candle_number];

            buy_index++;
           }
         else
            if((previous_relative_vigor_index < previous_relative_vigor_index_signal_line) && (current_relative_vigor_index > current_relative_vigor_index_signal_line))
              {
               SHORT_TRADES[sell_index] = Low[candle_number];

               sell_index++;
              }
        }
     }
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
//| Timer function                                                   |
//+------------------------------------------------------------------+
void OnTimer()
  {
//---

  }
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
//---

  }
//+------------------------------------------------------------------+
